<?
/*
  Virtual Freer
  http://freer.ir/virtual

  Copyright (c) 2011 Mohammad Hossein Beyram, freer.ir

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License v3 (http://www.gnu.org/licenses/gpl-3.0.html)
  as published by the Free Software Foundation.
*/
//-- اطلاعات کلی پلاگین
$pluginData[novinopay][type] 					= 'payment';
$pluginData[novinopay][name] 					= 'پرداخت الکترونیک نوینو';
$pluginData[novinopay][uniq] 					= 'novinopay';
$pluginData[novinopay][description] 				= 'مخصوص پرداخت با دروازه پرداخت <a href="https://novinopay.com">نوینو</a>';
$pluginData[novinopay][author][name] 			= 'Novino';
$pluginData[novinopay][author][url] 				= 'https://novinopay.com';
$pluginData[novinopay][author][email] 			= 'support@novinopay.com';

//-- فیلدهای تنظیمات پلاگین
$pluginData[novinopay][field][config][1][title] 	= 'مرچنت';
$pluginData[novinopay][field][config][1][name] 	= 'merchant';
$pluginData[novinopay][field][config][2][title] 	= 'عنوان خرید';
$pluginData[novinopay][field][config][2][name] 	= 'title';

//-- تابع انتقال به دروازه پرداخت
function gateway__novinopay($data)
{
	global $config,$db,$smarty;

    $data = [
        "merchant_id" => trim($data[merchant]),
        "amount" => round($data[amount]), //// rial
        "invoice_id" => "{$data[invoice_id]}",
        "description" => $data[title].' - '.$data[invoice_id],
        "callback_url" => "{$data[callback]}",
        "callback_method" => 'GET'
    ];

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, "https://api.novinopay.com/payment/ipg/v2/request");
    curl_setopt($curl, CURLOPT_HTTPHEADER, ["Content-Type" => "application/json"]);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data, JSON_UNESCAPED_UNICODE));
    curl_setopt($curl, CURLOPT_TIMEOUT, 50);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $curl_exec = curl_exec($curl);
    curl_close($curl);

    $result = json_decode($curl_exec);

    if (isset($result->status) && $result->status == 100) {
        ///save $result->data->authority in db
        $update[payment_rand] 	= $result->data->authority;
        $sql 					= $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "'.$data[invoice_id].'" LIMIT 1;');
        $db->execute($sql);

        header("Location: {$result->data->payment_url}");
        exit;

    } else {
        $errStatus 		= (isset($result->status) && $result->status != 100 && !empty($result->message)) ? $result->message : "Error connecting to web service";
		$data[title] 	= 'خطای سیستم';
		$data[message] 	= '<font color="red">در اتصال به درگاه نوینو مشکلی به وجود آمد٬ لطفا از درگاه سایر بانک‌ها استفاده نمایید.</font>'.$errStatus.'<br /><a href="index.php" class="button">بازگشت</a>';
		$query			= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
		$conf			= $db->fetch($query);
		$smarty->assign('config', $conf);
		$smarty->assign('data', $data);
		$smarty->display('message.tpl');
	}
}

//-- تابع بررسی وضعیت پرداخت
function callback__novinopay($data)
{
	global $db, $get;

    if (isset($_REQUEST["PaymentStatus"]) && $_REQUEST["PaymentStatus"] == "OK") {

        $Authority = (isset($_REQUEST["Authority"]) && !empty($_REQUEST["Authority"])) ? $_REQUEST["Authority"] : "";
        $InvoiceID = (isset($_REQUEST["InvoiceID"]) &&  !empty($_REQUEST["InvoiceID"])) ? $_REQUEST["InvoiceID"] : "";

        $sql 		= 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$Authority.'" LIMIT 1;';
        $payment 	= $db->fetch($sql);

        $data = [
            "merchant_id" => "{$data[merchant]}",
            "amount" => round($payment[payment_amount]), ///rial
            "authority" => $Authority
        ];

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, "https://api.novinopay.com/payment/ipg/v2/verification");
        curl_setopt($curl, CURLOPT_HTTPHEADER, ["Content-Type" => "application/json"]);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data, JSON_UNESCAPED_UNICODE));
        curl_setopt($curl, CURLOPT_TIMEOUT, 50);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $curl_exec = curl_exec($curl);
        curl_close($curl);

        $result = json_decode($curl_exec);

        if (isset($result->status) && $result->status == 100) {
            //-- آماده کردن خروجی
            $output[status]		= 1;
            $output[res_num]	= $Authority;
            $output[ref_num]	= $result->data->ref_id;
            $output[payment_id]	= $payment[payment_id];

        } else {
            $errStatus 		= (isset($result->status) && $result->status != "100") ? $result->message : "Error connecting to web service";
            //-- در تایید پرداخت مشکلی به‌وجود آمده است‌
            $output[status]	= 0;
            $output[message]= 'پرداخت توسط نوینو تایید نشد‌ : '.$errStatus;
        }

    }else{
        //-- شماره یکتا اشتباه است
        $output[status]	= 0;
        $output[message]= 'تراکنش لغو شد';
    }

	return $output;
}